/**
 * Like {@link Array#map}, but works with any iterable.
 *
 * @param iterable
 * @param cb
 * @returns an iterator.
 */
export declare function map<In, Out>(iterable: Iterable<In>, cb: (item: In, index: number) => Out): Generator<Out, void>;
export declare function some<In>(iterable: Iterable<In>, cb: (item: In) => boolean): boolean;
export declare function every<In>(iterable: Iterable<In>, cb: (item: In) => boolean): boolean;
export declare function find<Val>(iterable: Iterable<Val>, cb: (item: Val) => boolean): Val | undefined;
/**
 * Combines two iterables, they will be iterated in order
 *
 * @param iterables
 */
export declare function combinedIterator<T>(...iterables: Array<Iterable<T>>): Generator<T, void, undefined>;
